#ifdef GL_ES
precision highp float;
#endif

#if __VERSION__ < 130
#define in varying
#define outPixelColor gl_FragColor
#define texture(samp, uv) texture2D((samp), (uv))
#else
out vec4 outPixelColor;
#endif

#ifdef ENABLE_TEXTURE
in vec2 outTexCoord;
uniform sampler2D u_texture;
#endif
in vec4 outColor;

void main() {
#ifdef ENABLE_TEXTURE
    outPixelColor = texture(u_texture, outTexCoord) * outColor;
#else
    outPixelColor = outColor;
#endif
}
