#ifdef GL_ES
precision highp float;
#endif

#if __VERSION__ < 130
#define in attribute
#define out varying
#endif

uniform mat4 modelViewProjectionMatrix;
uniform vec4 color;
uniform vec3 translate;

in vec3 inPosition;

#ifdef ENABLE_TEXTURE
in vec2 inTexCoord;
out vec2 outTexCoord;
#endif


#ifdef ENABLE_VERTEX_COLOR
in vec4 inColor;
#endif

out vec4 outColor;

void main() {
    vec4 position = modelViewProjectionMatrix * vec4(translate + inPosition, 1.0);
    
#ifdef ENABLE_TEXTURE
    outTexCoord = inTexCoord;
#endif

#ifdef ENABLE_VERTEX_COLOR
    outColor = inColor;
#else
    outColor = color;
#endif

    gl_Position = position;
}

