
const float EPSILON = 0.0000001;  // TODO: depends on precision

const int GL_NEVER = 0x0200;
const int GL_LESS = 0x0201;
const int GL_EQUAL = 0x0202;
const int GL_LEQUAL = 0x0203;
const int GL_GREATER = 0x0204;
const int GL_NOTEQUAL = 0x0205;
const int GL_GEQUAL = 0x0206;
const int GL_ALWAYS = 0x0207;

#ifndef ALPHA_FUNC
	#define ALPHA_FUNC -1
#endif

// Uniforms
uniform int u_alphaFunc;
uniform float u_alphaFuncValue;

void alphaTest(float alpha) 
{
#if ALPHA_FUNC == 0x0207
	return;
#endif
#if ALPHA_FUNC == 0x0201
	if (alpha >= u_alphaFuncValue) {
		discard;
	}
#endif
#if ALPHA_FUNC == 0x0202
	if (u_alphaFuncValue - EPSILON > alpha || alpha > u_alphaFuncValue + EPSILON) {
		discard;
	}
#endif
#if ALPHA_FUNC == 0x0203
	if (alpha > u_alphaFuncValue) {
		discard;
	}
#endif
#if ALPHA_FUNC == 0x0204
	if (alpha <= u_alphaFuncValue) {
		discard;
	}
#endif
#if ALPHA_FUNC == 0x0205
	if (u_alphaFuncValue - EPSILON <= alpha && alpha <= u_alphaFuncValue + EPSILON) {
		discard;
	}
#endif
#if ALPHA_FUNC == 0x0206
	if (alpha < u_alphaFuncValue) {
		discard;
	}
#endif
#if ALPHA_FUNC == 0x0200
	discard;
#endif
#if ALPHA_FUNC == -1
	if (u_alphaFunc == GL_ALWAYS) {
		return;
	} else if (u_alphaFunc == GL_LESS) {
		if (alpha >= u_alphaFuncValue) {
			discard;
		}
	} else if (u_alphaFunc == GL_EQUAL) {
		if (u_alphaFuncValue - EPSILON > alpha || alpha > u_alphaFuncValue + EPSILON) {
			discard;
		}
	} else if (u_alphaFunc == GL_LEQUAL) {
		if (alpha > u_alphaFuncValue) {
			discard;
		}
	} else if (u_alphaFunc == GL_GREATER) {
		if (alpha <= u_alphaFuncValue) {
			discard;
		}
	} else if (u_alphaFunc == GL_NOTEQUAL) {
		if (u_alphaFuncValue - EPSILON <= alpha && alpha <= u_alphaFuncValue + EPSILON) {
			discard;
		}
	} else if (u_alphaFunc == GL_GEQUAL) {
		if (alpha < u_alphaFuncValue) {
			discard;
		}
	} else if (u_alphaFunc == GL_NEVER) {
		discard;
	}
#endif
}
