

// Uniforms
uniform bool u_texture0Enabled;
uniform bool u_texture1Enabled;
uniform bool u_texture2Enabled;

// Shader variables
vec4 texture0Color;
vec4 texture1Color;
vec4 texture2Color;

// Functions
void fetchTexture0Color();
void fetchTexture1Color();
void fetchTexture2Color();
void calcTexture0Environment(inout vec4 color);
void calcTexture1Environment(inout vec4 color);
void calcTexture2Environment(inout vec4 color);


void calcTextureColorContribution(inout vec4 color)
{
	// Fetch enabled texture colors
#if TEXTURE0_ENABLED == 1 || TEXTURE0_ENABLED == -1
	#if TEXTURE0_ENABLED == -1
	if (u_texture0Enabled) {
	#endif
		fetchTexture0Color();
	#if TEXTURE0_ENABLED == -1
	}
	#endif
#endif
	
#if TEXTURE1_ENABLED == 1 || TEXTURE1_ENABLED == -1
	#if TEXTURE1_ENABLED == -1
	if (u_texture1Enabled) {
	#endif
		fetchTexture1Color();
	#if TEXTURE1_ENABLED == -1
	}
	#endif
#endif
	
#if TEXTURE2_ENABLED == 1 || TEXTURE2_ENABLED == -1
	#if TEXTURE2_ENABLED == -1
	if (u_texture2Enabled) {
	#endif
		fetchTexture2Color();
	#if TEXTURE2_ENABLED == -1
	}
	#endif
#endif
	
	// Calc texture colors based on environment
#if TEXTURE0_ENABLED == 1 || TEXTURE0_ENABLED == -1
	#if TEXTURE0_ENABLED == -1
	if (u_texture0Enabled) {
	#endif
		calcTexture0Environment(color);
	#if TEXTURE0_ENABLED == -1
	}
	#endif
#endif

#if TEXTURE1_ENABLED == 1 || TEXTURE1_ENABLED == -1
	#if TEXTURE1_ENABLED == -1
	if (u_texture1Enabled) {
	#endif
		calcTexture1Environment(color);
	#if TEXTURE1_ENABLED == -1
	}
	#endif
#endif
	
#if TEXTURE2_ENABLED == 1 || TEXTURE2_ENABLED == -1
	#if TEXTURE2_ENABLED == -1
	if (u_texture2Enabled) {
	#endif
		calcTexture2Environment(color);
	#if TEXTURE2_ENABLED == -1
	}
	#endif
#endif
}
