

#if !defined(TEXCOORD0_ENABLED)
	#define TEXCOORD0_ENABLED -1
#endif

#if !defined(TEXTURE0_FORMAT)
	#define TEXTURE0_FORMAT -1
#endif

#if !defined(TEXTURE0_ENV_MODE)
	#define TEXTURE0_ENV_MODE -1
#endif

#if !defined(TEXTURE0_ENV_COMBINE_RGB)
	#define TEXTURE0_ENV_COMBINE_RGB -1
#endif

#if !defined(TEXTURE0_ENV_COMBINE_ALPHA)
	#define TEXTURE0_ENV_COMBINE_ALPHA -1
#endif

#if !defined(TEXTURE0_ENV_SRC0_RGB)
	#define TEXTURE0_ENV_SRC0_RGB -1
#endif

#if !defined(TEXTURE0_ENV_SRC1_RGB)
	#define TEXTURE0_ENV_SRC1_RGB -1
#endif

#if !defined(TEXTURE0_ENV_SRC2_RGB)
	#define TEXTURE0_ENV_SRC2_RGB -1
#endif

#if !defined(TEXTURE0_ENV_SRC0_ALPHA)
	#define TEXTURE0_ENV_SRC0_ALPHA -1
#endif

#if !defined(TEXTURE0_ENV_SRC1_ALPHA)
	#define TEXTURE0_ENV_SRC1_ALPHA -1
#endif

#if !defined(TEXTURE0_ENV_SRC2_ALPHA)
	#define TEXTURE0_ENV_SRC2_ALPHA -1
#endif

#if !defined(TEXTURE0_ENV_OPERAND0_RGB)
	#define TEXTURE0_ENV_OPERAND0_RGB -1
#endif

#if !defined(TEXTURE0_ENV_OPERAND1_RGB)
	#define TEXTURE0_ENV_OPERAND1_RGB -1
#endif

#if !defined(TEXTURE0_ENV_OPERAND2_RGB)
	#define TEXTURE0_ENV_OPERAND2_RGB -1
#endif

#if !defined(TEXTURE0_ENV_OPERAND0_ALPHA)
	#define TEXTURE0_ENV_OPERAND0_ALPHA -1
#endif

#if !defined(TEXTURE0_ENV_OPERAND1_ALPHA)
	#define TEXTURE0_ENV_OPERAND1_ALPHA -1
#endif

#if !defined(TEXTURE0_ENV_OPERAND2_ALPHA)
	#define TEXTURE0_ENV_OPERAND2_ALPHA -1
#endif

// Uniforms
#if TEXTURE_EXT0_ENABLED == 1
uniform samplerExternalOES u_texture0Sampler;
#else
uniform sampler2D u_texture0Sampler;
#endif
uniform int u_texture0Format;
uniform bool u_texCoord0Enabled;
uniform int u_texture0EnvMode;
uniform vec4 u_texture0EnvColor;
uniform int u_texture0EnvCombineRGB;
uniform int u_texture0EnvCombineAlpha;
uniform float u_texture0EnvRGBScale;
uniform float u_texture0EnvAlphaScale;
uniform float u_texture0EnvBlurAmount;

// Varyings
varying vec4 v_texCoord0;

void fetchTexture0Color()
{
	vec4 texCoord0;
#if TEXCOORD0_ENABLED == 1
	texCoord0 = v_texCoord0;
#endif
#if TEXCOORD0_ENABLED == 0
	texCoord0 = vec4(c_zerof, c_zerof, c_zerof, c_zerof);
#endif
#if TEXCOORD0_ENABLED == -1
	if (u_texCoord0Enabled) {
		texCoord0 = v_texCoord0;
	} else {
		texCoord0 = vec4(c_zerof, c_zerof, c_zerof, c_zerof);
	}
#endif

#if TEXTURE0_ENABLED == 1 || TEXTURE0_ENABLED == -1
	#if TEXTURE0_ENABLED == -1
	if (u_texture0Enabled) {
	#endif
		texture0Color = texture2D(u_texture0Sampler, texCoord0.st);
	#if TEXTURE0_ENABLED == -1
	}
	#endif
#endif
}

void calcTexture0Environment(inout vec4 color)
{	
#if TEXTURE0_ENV_MODE == 0x2100
	#if TEXTURE0_FORMAT == 0x1906
		color.a = color.a * texture0Color.a;
	#endif
#if TEXTURE0_FORMAT == 0x1909
		color.rgb = color.rgb * texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x190A
		color = color * texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x1907
		color.rgb = color.rgb * texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x1908
		color = color * texture0Color;
	#endif
#endif
#if TEXTURE0_ENV_MODE == 0x0104
	#if TEXTURE0_FORMAT == 0x1906
		color.a = color.a * texture0Color.a;
	#endif
#if TEXTURE0_FORMAT == 0x1909
		color.rgb = color.rgb + texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x190A
		color.rgb = color.rgb + texture0Color.rgb;
		color.a = color.a * texture0Color.a;
	#endif
#if TEXTURE0_FORMAT == 0x1907
		color.rgb = color.rgb + texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x1908
		color.rgb = color.rgb + texture0Color.rgb;
		color.a = color.a * texture0Color.a;
	#endif
#endif
#if TEXTURE0_ENV_MODE == 0x2101
	#if TEXTURE0_FORMAT == 0x1906
		// undefined
	#endif
#if TEXTURE0_FORMAT == 0x1909
		// undefined
	#endif
#if TEXTURE0_FORMAT == 0x190A
		// undefined
	#endif
#if TEXTURE0_FORMAT == 0x1907
		color.rgb = texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x1908
		color.rgb = mix(color.rgb, texture0Color.rgb, texture0Color.a);
	#endif
#endif
#if TEXTURE0_ENV_MODE == 0x0BE2
	#if TEXTURE0_FORMAT == 0x1906
		color.a = color.a * texture0Color.a;
	#endif
#if TEXTURE0_FORMAT == 0x1909
		color.rgb = mix(color.rgb, u_texture0EnvColor.rgb, texture0Color.rgb);
	#endif
#if TEXTURE0_FORMAT == 0x190A
		color.rgb = mix(color.rgb, u_texture0EnvColor.rgb, texture0Color.rgb);
		color.a = color.a * texture0Color.a;
	#endif
#if TEXTURE0_FORMAT == 0x1907
		color.rgb = mix(color.rgb, u_texture0EnvColor.rgb, texture0Color.rgb);
	#endif
#if TEXTURE0_FORMAT == 0x1908
		color.rgb = mix(color.rgb, u_texture0EnvColor.rgb, texture0Color.rgb);
		color.a = color.a * texture0Color.a;
	#endif
#endif
#if TEXTURE0_ENV_MODE == 0x1E01
	#if TEXTURE0_FORMAT == 0x1906
		color.a = texture0Color.a;
	#endif
#if TEXTURE0_FORMAT == 0x1909
		color.rgb = texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x190A
		color = texture0Color;
	#endif
#if TEXTURE0_FORMAT == 0x1907
		color.rgb = texture0Color.rgb;
	#endif
#if TEXTURE0_FORMAT == 0x1908
		color = texture0Color;
	#endif
#endif
#if TEXTURE0_ENV_MODE == 0x86FF
	vec4 sample0 = texture0Color;
	vec4 sample1 = texture2D(u_texture0Sampler, vec2(v_texCoord0.s - u_texture0EnvBlurAmount, v_texCoord0.t - u_texture0EnvBlurAmount));
	vec4 sample2 = texture2D(u_texture0Sampler, vec2(v_texCoord0.s + u_texture0EnvBlurAmount, v_texCoord0.t + u_texture0EnvBlurAmount));
	vec4 sample3 = texture2D(u_texture0Sampler, vec2(v_texCoord0.s - u_texture0EnvBlurAmount, v_texCoord0.t + u_texture0EnvBlurAmount));
	vec4 sample4 = texture2D(u_texture0Sampler, vec2(v_texCoord0.s + u_texture0EnvBlurAmount, v_texCoord0.t - u_texture0EnvBlurAmount));
	color = (sample0 + sample1 + sample2 + sample3 + sample4) / 5.0;
#endif
#if TEXTURE0_ENV_MODE == 0x8570
	vec4 arg0;
	vec4 arg1;
	vec4 arg2;

	// SRC RGB
	#if TEXTURE0_ENV_SRC0_RGB == 0
		arg0.rgb = texture0Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC0_RGB == 1
		arg0.rgb = texture1Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC0_RGB == 2
		arg0.rgb = texture2Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC0_RGB == 0x8576
		arg0.rgb = u_texture0EnvColor.rgb;
	#endif
#if TEXTURE0_ENV_SRC0_RGB == 0x8577
		arg0.rgb = v_frontColor.rgb;
	#endif
#if TEXTURE0_ENV_SRC0_RGB == 0x8578
		arg0.rgb = color.rgb;
	#endif

	// TODO: 0x0302 & 0x0303 exists in SDK but no idea what they are supposed to do in this context..
	#if TEXTURE0_ENV_OPERAND0_RGB == 0x0301
		arg0.rgb = 1.0 - arg0.rgb;
	#endif
		
	#if TEXTURE0_ENV_SRC1_RGB == 0
		arg1.rgb = texture0Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC1_RGB == 1
		arg1.rgb = texture1Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC1_RGB == 2
		arg1.rgb = texture2Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC1_RGB == 0x8576
		arg1.rgb = u_texture0EnvColor.rgb;
	#endif
#if TEXTURE0_ENV_SRC1_RGB == 0x8577
		arg1.rgb = v_frontColor.rgb;
	#endif
#if TEXTURE0_ENV_SRC1_RGB == 0x8578
		arg1.rgb = color.rgb;
	#endif
	
	#if TEXTURE0_ENV_OPERAND0_RGB == 0x0301
		arg1.rgb = 1.0 - arg1.rgb;
	#endif

	#if TEXTURE0_ENV_SRC2_RGB == 0
		arg2.rgb = texture0Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC2_RGB == 1
		arg2.rgb = texture1Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC2_RGB == 2
		arg2.rgb = texture2Color.rgb;
	#endif
#if TEXTURE0_ENV_SRC2_RGB == 0x8576
		arg2.rgb = u_texture0EnvColor.rgb;
	#endif
#if TEXTURE0_ENV_SRC2_RGB == 0x8577
		arg2.rgb = v_frontColor.rgb;
	#endif
#if TEXTURE0_ENV_SRC2_RGB == 0x8578
		arg2.rgb = color.rgb;
	#endif
		
	#if TEXTURE0_ENV_OPERAND2_RGB == 0x0301
		arg2.rgb = 1.0 - arg2.rgb;
	#endif
		
	// SRC ALPHA
	#if TEXTURE0_ENV_SRC0_ALPHA == 0
		arg0.a = texture0Color.a;
	#endif
#if TEXTURE0_ENV_SRC0_ALPHA == 1
		arg0.a = texture1Color.a;
	#endif
#if TEXTURE0_ENV_SRC0_ALPHA == 2
		arg0.a = texture2Color.a;
	#endif
#if TEXTURE0_ENV_SRC0_ALPHA == 0x8576
		arg0.a = u_texture0EnvColor.a;
	#endif
#if TEXTURE0_ENV_SRC0_ALPHA == 0x8577
		arg0.a = v_frontColor.a;
	#endif
#if TEXTURE0_ENV_SRC0_ALPHA == 0x8578
		arg0.a = color.a;
	#endif
		
	#if TEXTURE0_ENV_OPERAND0_ALPHA == 0x0303
		arg0.a = 1.0 - arg0.a;
	#endif
		
	#if TEXTURE0_ENV_SRC1_ALPHA == 0
		arg1.a = texture0Color.a;
	#endif
#if TEXTURE0_ENV_SRC1_ALPHA == 1
		arg1.a = texture1Color.a;
	#endif
#if TEXTURE0_ENV_SRC1_ALPHA == 2
		arg1.a = texture2Color.a;
	#endif
#if TEXTURE0_ENV_SRC1_ALPHA == 0x8576
		arg1.a = u_texture0EnvColor.a;
	#endif
#if TEXTURE0_ENV_SRC1_ALPHA == 0x8577
		arg1.a = v_frontColor.a;
	#endif
#if TEXTURE0_ENV_SRC1_ALPHA == 0x8578
		arg1.a = color.a;
	#endif
		
	#if TEXTURE0_ENV_OPERAND0_ALPHA == 0x0303
		arg1.a = 1.0 - arg1.a;
	#endif
		
	#if TEXTURE0_ENV_SRC2_ALPHA == 0
		arg2.a = texture0Color.a;
	#endif
#if TEXTURE0_ENV_SRC2_ALPHA == 1
		arg2.a = texture1Color.a;
	#endif
#if TEXTURE0_ENV_SRC2_ALPHA == 2
		arg2.a = texture2Color.a;
	#endif
#if TEXTURE0_ENV_SRC2_ALPHA == 0x8576
		arg2.a = u_texture0EnvColor.a;
	#endif
#if TEXTURE0_ENV_SRC2_ALPHA == 0x8577
		arg2.a = v_frontColor.a;
	#endif
#if TEXTURE0_ENV_SRC2_ALPHA == 0x8578
		arg2.a = color.a;
	#endif
		
	#if TEXTURE0_ENV_OPERAND2_ALPHA == 0x0303
		arg2.a = 1.0 - arg2.a;
	#endif
		
	// COMBINE_RGB
	#if TEXTURE0_ENV_COMBINE_RGB == 0x1E01
		color.rgb = arg0.rgb;
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x2100
		color.rgb = arg0.rgb * arg1.rgb;
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x0104
		color.rgb = arg0.rgb + arg1.rgb;
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x8574
		color.rgb = arg0.rgb + arg1.rgb - 0.5;
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x8575
		color.rgb = mix(arg1.rgb, arg0.rgb, arg2.rgb);
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x84E7
		color.rgb = arg0.rgb - arg1.rgb;
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x86AE
		color.r = 4.0*((arg0.r - 0.5)*(arg1.r - 0.5) + (arg0.g - 0.5)*(arg1.g - 0.5) + (arg0.b - 0.5)*(arg1.b - 0.5));
		color.g = color.r;
		color.b = color.r;
	#endif
#if TEXTURE0_ENV_COMBINE_RGB == 0x86AF
		color.r = 4.0*((arg0.r - 0.5)*(arg1.r - 0.5) + (arg0.g - 0.5)*(arg1.g - 0.5) + (arg0.b - 0.5)*(arg1.b - 0.5));
		color.g = color.r;
		color.b = color.r;
		color.a = color.r;
	#endif

	// COMBINE_ALPHA
	#if TEXTURE0_ENV_COMBINE_ALPHA == 0x1E01
		color.a = arg0.a;
	#endif
#if TEXTURE0_ENV_COMBINE_ALPHA == 0x2100
		color.a = arg0.a * arg1.a;
	#endif
#if TEXTURE0_ENV_COMBINE_ALPHA == 0x0104
		color.a = arg0.a + arg1.a;
	#endif
#if TEXTURE0_ENV_COMBINE_ALPHA == 0x8574
		color.a = arg0.a + arg1.a - 0.5;
	#endif
#if TEXTURE0_ENV_COMBINE_ALPHA == 0x8575
		color.a = mix(arg1.a, arg0.a, arg2.a);
	#endif
#if TEXTURE0_ENV_COMBINE_ALPHA == 0x84E7
		color.a = arg0.a - arg1.a;
	#endif
#endif
		
	color.rgb = color.rgb * u_texture0EnvRGBScale;
	color.a = color.a * u_texture0EnvAlphaScale;
	color = clamp(color, c_zerof, c_onef);
}
