

#if !defined(TEXCOORD1_ENABLED)
	#define TEXCOORD1_ENABLED -1
#endif

#if !defined(TEXTURE1_FORMAT)
	#define TEXTURE1_FORMAT -1
#endif

#if !defined(TEXTURE1_ENV_MODE)
	#define TEXTURE1_ENV_MODE -1
#endif

#if !defined(TEXTURE1_ENV_COMBINE_RGB)
	#define TEXTURE1_ENV_COMBINE_RGB -1
#endif

#if !defined(TEXTURE1_ENV_COMBINE_ALPHA)
	#define TEXTURE1_ENV_COMBINE_ALPHA -1
#endif

#if !defined(TEXTURE1_ENV_SRC0_RGB)
	#define TEXTURE1_ENV_SRC0_RGB -1
#endif

#if !defined(TEXTURE1_ENV_SRC1_RGB)
	#define TEXTURE1_ENV_SRC1_RGB -1
#endif

#if !defined(TEXTURE1_ENV_SRC2_RGB)
	#define TEXTURE1_ENV_SRC2_RGB -1
#endif

#if !defined(TEXTURE1_ENV_SRC0_ALPHA)
	#define TEXTURE1_ENV_SRC0_ALPHA -1
#endif

#if !defined(TEXTURE1_ENV_SRC1_ALPHA)
	#define TEXTURE1_ENV_SRC1_ALPHA -1
#endif

#if !defined(TEXTURE1_ENV_SRC2_ALPHA)
	#define TEXTURE1_ENV_SRC2_ALPHA -1
#endif

#if !defined(TEXTURE1_ENV_OPERAND0_RGB)
	#define TEXTURE1_ENV_OPERAND0_RGB -1
#endif

#if !defined(TEXTURE1_ENV_OPERAND1_RGB)
	#define TEXTURE1_ENV_OPERAND1_RGB -1
#endif

#if !defined(TEXTURE1_ENV_OPERAND2_RGB)
	#define TEXTURE1_ENV_OPERAND2_RGB -1
#endif

#if !defined(TEXTURE1_ENV_OPERAND0_ALPHA)
	#define TEXTURE1_ENV_OPERAND0_ALPHA -1
#endif

#if !defined(TEXTURE1_ENV_OPERAND1_ALPHA)
	#define TEXTURE1_ENV_OPERAND1_ALPHA -1
#endif

#if !defined(TEXTURE1_ENV_OPERAND2_ALPHA)
	#define TEXTURE1_ENV_OPERAND2_ALPHA -1
#endif

// Uniforms
#if TEXTURE_EXT1_ENABLED == 1
uniform samplerExternalOES u_texture1Sampler;
#else
uniform sampler2D u_texture1Sampler;
#endif
uniform int u_texture1Format;
uniform bool u_texCoord0Enabled;
uniform int u_texture1EnvMode;
uniform vec4 u_texture1EnvColor;
uniform int u_texture1EnvCombineRGB;
uniform int u_texture1EnvCombineAlpha;
uniform float u_texture1EnvRGBScale;
uniform float u_texture1EnvAlphaScale;
uniform float u_texture1EnvBlurAmount;

// Varyings
varying vec4 v_texCoord1;

void fetchTexture1Color()
{
	vec4 texCoord1;
#if TEXCOORD1_ENABLED == 1
	texCoord1 = v_texCoord1;
#endif
#if TEXCOORD1_ENABLED == 0
	texCoord1 = vec4(c_zerof, c_zerof, c_zerof, c_zerof);
#endif
#if TEXCOORD1_ENABLED == -1
	if (u_texCoord1Enabled) {
		texCoord1 = v_texCoord1;
	} else {
		texCoord1 = vec4(c_zerof, c_zerof, c_zerof, c_zerof);
	}
#endif

#if TEXTURE1_ENABLED == 1 || TEXTURE1_ENABLED == -1
	#if TEXTURE1_ENABLED == -1
	if (u_texture1Enabled) {
	#endif
		texture1Color = texture2D(u_texture1Sampler, texCoord1.st);
	#if TEXTURE1_ENABLED == -1
	}
	#endif
#endif
}

void calcTexture1Environment(inout vec4 color)
{	
#if TEXTURE1_ENV_MODE == 0x2100
	#if TEXTURE1_FORMAT == 0x1906
		color.a = color.a * texture1Color.a;
	#endif
#if TEXTURE1_FORMAT == 0x1909
		color.rgb = color.rgb * texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x190A
		color = color * texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x1907
		color.rgb = color.rgb * texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x1908
		color = color * texture1Color;
	#endif
#endif
#if TEXTURE1_ENV_MODE == 0x0104
	#if TEXTURE1_FORMAT == 0x1906
		color.a = color.a * texture1Color.a;
	#endif
#if TEXTURE1_FORMAT == 0x1909
		color.rgb = color.rgb + texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x190A
		color.rgb = color.rgb + texture1Color.rgb;
		color.a = color.a * texture1Color.a;
	#endif
#if TEXTURE1_FORMAT == 0x1907
		color.rgb = color.rgb + texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x1908
		color.rgb = color.rgb + texture1Color.rgb;
		color.a = color.a * texture1Color.a;
	#endif
#endif
#if TEXTURE1_ENV_MODE == 0x2101
	#if TEXTURE1_FORMAT == 0x1906
		// undefined
	#endif
#if TEXTURE1_FORMAT == 0x1909
		// undefined
	#endif
#if TEXTURE1_FORMAT == 0x190A
		// undefined
	#endif
#if TEXTURE1_FORMAT == 0x1907
		color.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x1908
		color.rgb = mix(color.rgb, texture1Color.rgb, texture1Color.a);
	#endif
#endif
#if TEXTURE1_ENV_MODE == 0x0BE2
	#if TEXTURE1_FORMAT == 0x1906
		color.a = color.a * texture1Color.a;
	#endif
#if TEXTURE1_FORMAT == 0x1909
		color.rgb = mix(color.rgb, u_texture1EnvColor.rgb, texture1Color.rgb);
	#endif
#if TEXTURE1_FORMAT == 0x190A
		color.rgb = mix(color.rgb, u_texture1EnvColor.rgb, texture1Color.rgb);
		color.a = color.a * texture1Color.a;
	#endif
#if TEXTURE1_FORMAT == 0x1907
		color.rgb = mix(color.rgb, u_texture1EnvColor.rgb, texture1Color.rgb);
	#endif
#if TEXTURE1_FORMAT == 0x1908
		color.rgb = mix(color.rgb, u_texture1EnvColor.rgb, texture1Color.rgb);
		color.a = color.a * texture1Color.a;
	#endif
#endif
#if TEXTURE1_ENV_MODE == 0x1E01
	#if TEXTURE1_FORMAT == 0x1906
		color.a = texture1Color.a;
	#endif
#if TEXTURE1_FORMAT == 0x1909
		color.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x190A
		color = texture1Color;
	#endif
#if TEXTURE1_FORMAT == 0x1907
		color.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_FORMAT == 0x1908
		color = texture1Color;
	#endif
#endif
#if TEXTURE1_ENV_MODE == 0x86FF
	vec4 sample0 = texture1Color;
	vec4 sample1 = texture2D(u_texture1Sampler, vec2(v_texCoord1.s - u_texture1EnvBlurAmount, v_texCoord1.t - u_texture1EnvBlurAmount));
	vec4 sample2 = texture2D(u_texture1Sampler, vec2(v_texCoord1.s + u_texture1EnvBlurAmount, v_texCoord1.t + u_texture1EnvBlurAmount));
	vec4 sample3 = texture2D(u_texture1Sampler, vec2(v_texCoord1.s - u_texture1EnvBlurAmount, v_texCoord1.t + u_texture1EnvBlurAmount));
	vec4 sample4 = texture2D(u_texture1Sampler, vec2(v_texCoord1.s + u_texture1EnvBlurAmount, v_texCoord1.t - u_texture1EnvBlurAmount));
	color = (sample0 + sample1 + sample2 + sample3 + sample4) / 5.0;
#endif
#if TEXTURE1_ENV_MODE == 0x8570
	vec4 arg0;
	vec4 arg1;
	vec4 arg2;

	// SRC RGB
	#if TEXTURE1_ENV_SRC0_RGB == 0
		arg0.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC0_RGB == 1
		arg0.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC0_RGB == 2
		arg0.rgb = texture2Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC0_RGB == 0x8576
		arg0.rgb = u_texture1EnvColor.rgb;
	#endif
#if TEXTURE1_ENV_SRC0_RGB == 0x8577
		arg0.rgb = v_frontColor.rgb;
	#endif
#if TEXTURE1_ENV_SRC0_RGB == 0x8578
		arg0.rgb = color.rgb;
	#endif

	// TODO: 0x0302 & 0x0303 exists in SDK but no idea what they are supposed to do in this context..
	#if TEXTURE1_ENV_OPERAND0_RGB == 0x0301
		arg0.rgb = 1.0 - arg0.rgb;
	#endif
		
	#if TEXTURE1_ENV_SRC1_RGB == 0
		arg1.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC1_RGB == 1
		arg1.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC1_RGB == 2
		arg1.rgb = texture2Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC1_RGB == 0x8576
		arg1.rgb = u_texture1EnvColor.rgb;
	#endif
#if TEXTURE1_ENV_SRC1_RGB == 0x8577
		arg1.rgb = v_frontColor.rgb;
	#endif
#if TEXTURE1_ENV_SRC1_RGB == 0x8578
		arg1.rgb = color.rgb;
	#endif
	
	#if TEXTURE1_ENV_OPERAND0_RGB == 0x0301
		arg1.rgb = 1.0 - arg1.rgb;
	#endif

	#if TEXTURE1_ENV_SRC2_RGB == 0
		arg2.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC2_RGB == 1
		arg2.rgb = texture1Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC2_RGB == 2
		arg2.rgb = texture2Color.rgb;
	#endif
#if TEXTURE1_ENV_SRC2_RGB == 0x8576
		arg2.rgb = u_texture1EnvColor.rgb;
	#endif
#if TEXTURE1_ENV_SRC2_RGB == 0x8577
		arg2.rgb = v_frontColor.rgb;
	#endif
#if TEXTURE1_ENV_SRC2_RGB == 0x8578
		arg2.rgb = color.rgb;
	#endif
		
	#if TEXTURE1_ENV_OPERAND2_RGB == 0x0301
		arg2.rgb = 1.0 - arg2.rgb;
	#endif
		
	// SRC ALPHA
	#if TEXTURE1_ENV_SRC0_ALPHA == 0
		arg0.a = texture1Color.a;
	#endif
#if TEXTURE1_ENV_SRC0_ALPHA == 1
		arg0.a = texture1Color.a;
	#endif
#if TEXTURE1_ENV_SRC0_ALPHA == 2
		arg0.a = texture2Color.a;
	#endif
#if TEXTURE1_ENV_SRC0_ALPHA == 0x8576
		arg0.a = u_texture1EnvColor.a;
	#endif
#if TEXTURE1_ENV_SRC0_ALPHA == 0x8577
		arg0.a = v_frontColor.a;
	#endif
#if TEXTURE1_ENV_SRC0_ALPHA == 0x8578
		arg0.a = color.a;
	#endif
		
	#if TEXTURE1_ENV_OPERAND0_ALPHA == 0x0303
		arg0.a = 1.0 - arg0.a;
	#endif
		
	#if TEXTURE1_ENV_SRC1_ALPHA == 0
		arg1.a = texture1Color.a;
	#endif
#if TEXTURE1_ENV_SRC1_ALPHA == 1
		arg1.a = texture1Color.a;
	#endif
#if TEXTURE1_ENV_SRC1_ALPHA == 2
		arg1.a = texture2Color.a;
	#endif
#if TEXTURE1_ENV_SRC1_ALPHA == 0x8576
		arg1.a = u_texture1EnvColor.a;
	#endif
#if TEXTURE1_ENV_SRC1_ALPHA == 0x8577
		arg1.a = v_frontColor.a;
	#endif
#if TEXTURE1_ENV_SRC1_ALPHA == 0x8578
		arg1.a = color.a;
	#endif
		
	#if TEXTURE1_ENV_OPERAND0_ALPHA == 0x0303
		arg1.a = 1.0 - arg1.a;
	#endif
		
	#if TEXTURE1_ENV_SRC2_ALPHA == 0
		arg2.a = texture1Color.a;
	#endif
#if TEXTURE1_ENV_SRC2_ALPHA == 1
		arg2.a = texture1Color.a;
	#endif
#if TEXTURE1_ENV_SRC2_ALPHA == 2
		arg2.a = texture2Color.a;
	#endif
#if TEXTURE1_ENV_SRC2_ALPHA == 0x8576
		arg2.a = u_texture1EnvColor.a;
	#endif
#if TEXTURE1_ENV_SRC2_ALPHA == 0x8577
		arg2.a = v_frontColor.a;
	#endif
#if TEXTURE1_ENV_SRC2_ALPHA == 0x8578
		arg2.a = color.a;
	#endif
		
	#if TEXTURE1_ENV_OPERAND2_ALPHA == 0x0303
		arg2.a = 1.0 - arg2.a;
	#endif
		
	// COMBINE_RGB
	#if TEXTURE1_ENV_COMBINE_RGB == 0x1E01
		color.rgb = arg0.rgb;
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x2100
		color.rgb = arg0.rgb * arg1.rgb;
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x0104
		color.rgb = arg0.rgb + arg1.rgb;
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x8574
		color.rgb = arg0.rgb + arg1.rgb - 0.5;
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x8575
		color.rgb = mix(arg1.rgb, arg0.rgb, arg2.rgb);
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x84E7
		color.rgb = arg0.rgb - arg1.rgb;
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x86AE
		color.r = 4.0*((arg0.r - 0.5)*(arg1.r - 0.5) + (arg0.g - 0.5)*(arg1.g - 0.5) + (arg0.b - 0.5)*(arg1.b - 0.5));
		color.g = color.r;
		color.b = color.r;
	#endif
#if TEXTURE1_ENV_COMBINE_RGB == 0x86AF
		color.r = 4.0*((arg0.r - 0.5)*(arg1.r - 0.5) + (arg0.g - 0.5)*(arg1.g - 0.5) + (arg0.b - 0.5)*(arg1.b - 0.5));
		color.g = color.r;
		color.b = color.r;
		color.a = color.r;
	#endif

	// COMBINE_ALPHA
	#if TEXTURE1_ENV_COMBINE_ALPHA == 0x1E01
		color.a = arg0.a;
	#endif
#if TEXTURE1_ENV_COMBINE_ALPHA == 0x2100
		color.a = arg0.a * arg1.a;
	#endif
#if TEXTURE1_ENV_COMBINE_ALPHA == 0x0104
		color.a = arg0.a + arg1.a;
	#endif
#if TEXTURE1_ENV_COMBINE_ALPHA == 0x8574
		color.a = arg0.a + arg1.a - 0.5;
	#endif
#if TEXTURE1_ENV_COMBINE_ALPHA == 0x8575
		color.a = mix(arg1.a, arg0.a, arg2.a);
	#endif
#if TEXTURE1_ENV_COMBINE_ALPHA == 0x84E7
		color.a = arg0.a - arg1.a;
	#endif
#endif
		
	color.rgb = color.rgb * u_texture1EnvRGBScale;
	color.a = color.a * u_texture1EnvAlphaScale;
	color = clamp(color, c_zerof, c_onef);
}
