-- システム関数の読み込み
dofile("System/lua/mmdagent.lua")
dofile("System/lua/android.lua")
settings = dofile("System/lua/settings.lua")

ProgressDialog.start("now loading...")

rocket:LoadFontFace("AppData/font.ttf")

-- ダンプ
dofile("System/lua/dumper.lua")
function dump(...)
  print(DataDumper(...), "\n---")
end

-- セーブ・ロード
TableLoader = dofile("System/lua/persistence.lua")

-- UI表示・非表示制御
ui_visible = true
local function ui_switcher()
  if (ui_visible) then
    MMDAgent.sendMessage("ROCKET_HIDE", "")
    ui_visible = false
  else
    MMDAgent.sendMessage("ROCKET_SHOW", "")
    ui_visible = true
  end
end

MMDAgent.addMessageListener("", "KEY", "c", ui_switcher)

-- util
function readfile(file)
  local result = ''
  io.input(file)
  while true do
    text = io.read()
    if text == nil then break end
    result = result..text.."\n"
  end
  return result
end

function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end

function dofile(file)
  local path = MMDAgent.dirname(file)
  local text = "local LOCAL_PATH = [["..path.."]]\n"
  text = text..readfile(file)
  local func = load(text)
  if (func) then
    return func()
  end
end

-- ドキュメントの読み込み用関数
RocketContext = rocket.contexts["main"]
document_list = {}
function ShowDocument(file)
  local document
  -- すでにロード済みならロードしない
  if (document_list[file]) then
    document = document_list[file]
    document:PullToFront()
  else
    document = RocketContext:LoadDocument(file)
    document_list[file] = document
    -- タイトルの置換
    local element = document:GetElementById('title')
    if (element) then element.inner_rml = document.title end
  end
  -- 表示させる
  document:Show()
  
  return document
end

local function renderPostEffect()
  MMDAgent.renderPostEffect()
end
MMDAgent.addRenderListener("POST_EFFECT", renderPostEffect, 1000)

local function renderRocket()
  MMDAgent.renderRocket()
end
MMDAgent.addRenderListener("ROCKET", renderRocket, 0x7FFFFFFF)

-- メニュー画面の読み込み
--ShowDocument("System/UI/pose-sideMenu.rml")
ShowDocument("System/UI/touch.rml")
--ShowDocument("System/UI/top.rml")
