-- KEVAtB^

local mainTexture
local instance = {}
local weight = {}
local range = 0
local offsetTableX = {}
local offsetTableY = {}
local WEIGHT_SIZE = 10

-- program
local program = MMDAgent.createShaderProgram()
program.attributes = {inPosition = 0, inTexCoord = 1}
program.uniforms = {texture = -1, offset = -1, weight = -1}
program:build(readfile(LOCAL_PATH.."/gaussian.vsh"), readfile(LOCAL_PATH.."/gaussian.fsh"))

local function generate_offset(oneTexelX, oneTexelY)
  local offset = {}
  
  for i = 1, WEIGHT_SIZE do
    local index = (i - 1) * 2 + 1
    offset[index] = oneTexelX * i
    offset[index + 1] = oneTexelY * i
  end
  
  return offset
end

-- gaussiantB^̏d݌WZo
instance.setRange = function(value)
  range = value
  local t = 0.0
  local d = range * range / 100
  for i = 0, WEIGHT_SIZE do
      local r = 1.0 + 2.0 * i
      local w = math.exp(-0.5 * (r * r) / d)
      weight[i+1] = w
      if (i > 0) then
        w = w * 2.0
      end
      t = t + w
  end
  for i = 0, WEIGHT_SIZE do
      weight[i+1] = weight[i+1] / t
  end
end

instance.setTexture = function(texture)
  mainTexture = texture
  
  local texelWidth, texelHeight = mainTexture:texelSize()
  local screenWidth, screenHeight = MMDAgent.getScreenSize()
  local oneTexelX = texelWidth / screenWidth
  local oneTexelY = texelHeight / screenHeight
  offsetTableX = generate_offset(oneTexelX, 0)
  offsetTableY = generate_offset(0, oneTexelY)
end

instance.getRange = function()
  return range
end

instance.render = function()
  -- bind
  program:bind()
  local vao = MMDAgent.getScreenVAO()
  vao:bind()
  
  -- uniform
  MMDAgent.setUniformTexture(program.uniforms.texture, 0, mainTexture)
  gl.Uniform1(program.uniforms.weight, weight, 10)
  
  -- Ƀu[
  gl.Uniform2(program.uniforms.offset, offsetTableX, 9)
  vao.drawScreenElements()
  
  -- cɃu[
  gl.Uniform2(program.uniforms.offset, offsetTableY, 9)
  vao.drawScreenElements()
  
  -- unbind
  vao:unbind()
  program:unbind()
end

return instance