#ifdef GL_ES
precision highp float;
#endif

uniform sampler2D textureA;
uniform sampler2D textureB;
varying vec2      outTexCoord;

void main(void){
  vec4 colorA = texture2D(textureA, outTexCoord);
  vec4 colorB = texture2D(textureB, outTexCoord);
  
  if (colorA.r < 0.5)
  {
    gl_FragColor.r = 2.0 * (colorA.r * colorB.r);
  }
  else
  {
    gl_FragColor.r = 1.0 - 2.0 * (1.0 - colorA.r) * (1.0 - colorB.r);
  }
  
  if (colorA.g < 0.5)
  {
    gl_FragColor.g = 2.0 * (colorA.g * colorB.g);
  }
  else
  {
    gl_FragColor.g = 1.0 - 2.0 * (1.0 - colorA.g) * (1.0 - colorB.g);
  }
  
  if (colorA.b < 0.5)
  {
    gl_FragColor.b = 2.0 * (colorA.b * colorB.b);
  }
  else
  {
    gl_FragColor.b = 1.0 - 2.0 * (1.0 - colorA.b) * (1.0 - colorB.b);
  }
  gl_FragColor.a = colorA.a;
}