local instance = {}

-- variables
local textureA
local textureB

-- program
local program = MMDAgent.createShaderProgram()
program.attributes = {inPosition = 0, inTexCoord = 1}
program.uniforms = {textureA = -1, textureB = -1}
program:build(readfile(LOCAL_PATH.."/overlay.vsh"), readfile(LOCAL_PATH.."/overlay.fsh"))

instance.setTexture = function(A, B)
  textureA = A
  textureB = B
end

instance.render = function()
  gl.Disable(gl.BLEND)
  -- bind
  program:bind()
  local vao = MMDAgent.getScreenVAO()
  vao:bind()
  
  -- uniform
  MMDAgent.setUniformTexture(program.uniforms.textureA, 0, textureA)
  MMDAgent.setUniformTexture(program.uniforms.textureB, 1, textureB)
  
  -- draw
  vao.drawScreenElements()
  
  -- unbind
  vao:unbind()
  program:unbind()
  
  gl.Enable(gl.BLEND)
end

return instance