local instance = {}

local mainTexture = MMDAgent.getTexture2D("MAIN")
local fbo = MMDAgent.createFBO()
fbo:attachTexture(0, mainTexture)

local gaussianTexture = MMDAgent.createScreenTexture()
local gaussianFBO = MMDAgent.createFBO()
gaussianFBO:attachTexture(0, gaussianTexture)

-- ガウシアン
local gaussian = dofile(MMDAgent.upDir(LOCAL_PATH).."/Gaussian/gaussian.lua")
gaussian.setTexture(mainTexture)
-- オーバーレイ
local overlay = dofile(MMDAgent.upDir(LOCAL_PATH).."/Overlay/overlay.lua")
overlay.setTexture(mainTexture, gaussianTexture)


instance.setRange = function(value)
  gaussian.setRange(value)
end

instance.render = function()
  -- ガウシアン
  gaussianFBO:bind()
  gaussian.render()
  gaussianFBO:unbind()
  
  -- オーバーレイ
  fbo:bind()
  overlay.render()
  fbo:unbind()
end

return instance